<?php

namespace Modules\Qc\Http\Controllers;

use Exception;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Auth;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Modules\Qc\Entities\DailyQualityBagInspectionData;
use Modules\Qc\Entities\DailyQualityBagInspectionDataHeader;

class DailyQualityBagInspectionDataController extends Controller
{
    public function save(Request $request)
    {
        try {
            $rec = new DailyQualityBagInspectionDataHeader();
            $rec->reference_no = $request->get('reference_no');
            $rec->customer_order_plan_data_id = $request->get('customer_order_plan_data_id');
            $rec->product_primary_id = $request->get('product_primary_id');
            $rec->date = $request->get('date');
            $rec->factory = $request->get('factory');
            $rec->shift = $request->get('shift');
            $rec->size_of_product = $request->get('size_of_product');
            $rec->user_id = Auth::user()->id;
            if ($rec->save()) {
                $rec_arr = $request->get("bi_data");
                for ($i = 0; $i < count($rec_arr); $i++) {
                    $biData = json_decode($rec_arr[$i]);

                    $rec_data = new DailyQualityBagInspectionData();
                    $rec_data->dq_bag_inspection_id = $rec->dq_bag_inspection_id;
                    $rec_data->hour = $biData->hour;
                    $rec_data->print_damage = $biData->print_damage;
                    $rec_data->unseal_damage = $biData->unseal_damage;
                    $rec_data->seal_burning = $biData->seal_burning;
                    $rec_data->bag_damage = $biData->bag_damage;
                    $rec_data->plant_hole_damage = $biData->plant_hole_damage;
                    $rec_data->upside_down = $biData->upside_down;
                    $rec_data->production_damage = $biData->production_damage;
                    $rec_data->qc_print_damage = $biData->qc_print_damage;
                    $rec_data->qc_unseal_damage = $biData->qc_unseal_damage;
                    $rec_data->qc_seal_burning = $biData->qc_seal_burning;
                    $rec_data->qc_bag_damage = $biData->qc_bag_damage;
                    $rec_data->qc_plant_hole_damage = $biData->qc_plant_hole_damage;
                    $rec_data->qc_upside_down = $biData->qc_upside_down;
                    $rec_data->qc_production_damage = $biData->qc_production_damage;
                    $rec_data->remarks = $biData->remarks;
                    $rec_data->save();
                }
            }
            $responseBody = $this->responseBody(true, "DailyQualityBagInspectionDataController", "saved", true);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "DailyQualityBagInspectionDataController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }

    public function update(Request $request, $id)
    {

        try {

            if ($this->delete($id)) {
                $rec = DailyQualityBagInspectionDataHeader::find($id);
                $rec->reference_no = $request->get('reference_no');
                $rec->customer_order_plan_data_id = $request->get('customer_order_plan_data_id');
                $rec->product_primary_id = $request->get('product_primary_id');
                $rec->date = $request->get('date');
                $rec->factory = $request->get('factory');
                $rec->shift = $request->get('shift');
                $rec->size_of_product = $request->get('size_of_product');
                $rec->update();

                $rec_arr = $request->get("bi_data");
                if ($rec_arr) {
                    for ($i = 0; $i < count($rec_arr); $i++) {
                        $biData = json_decode($rec_arr[$i]);
                        $rec_data = new DailyQualityBagInspectionData();
                        $rec_data->dq_bag_inspection_id = $rec->dq_bag_inspection_id;
                        $rec_data->hour = $biData->hour;
                        $rec_data->print_damage = $biData->print_damage;
                        $rec_data->unseal_damage = $biData->unseal_damage;
                        $rec_data->seal_burning = $biData->seal_burning;
                        $rec_data->bag_damage = $biData->bag_damage;
                        $rec_data->plant_hole_damage = $biData->plant_hole_damage;
                        $rec_data->upside_down = $biData->upside_down;
                        $rec_data->production_damage = $biData->production_damage;
                        $rec_data->qc_print_damage = $biData->qc_print_damage;
                        $rec_data->qc_unseal_damage = $biData->qc_unseal_damage;
                        $rec_data->qc_seal_burning = $biData->qc_seal_burning;
                        $rec_data->qc_bag_damage = $biData->qc_bag_damage;
                        $rec_data->qc_plant_hole_damage = $biData->qc_plant_hole_damage;
                        $rec_data->qc_upside_down = $biData->qc_upside_down;
                        $rec_data->qc_production_damage = $biData->qc_production_damage;
                        $rec_data->remarks = $biData->remarks;
                        $rec_data->save();
                    }
                }
            }

            $responseBody = $this->responseBody(true, "DailyQualityBagInspectionDataController", "update", true);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "DailyQualityBagInspectionDataController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }

    public function delete($id)
    {
        try {
            $rec_data = DailyQualityBagInspectionData::where('dq_bag_inspection_id', '=', $id)->get();
            foreach ($rec_data as $data) {
                $data->delete();
            }
            return true;
        } catch (Exception $exception) {
            return false;
        }
    }

    public function getBiData($id)
    {
        try {
            $recordHead = DailyQualityBagInspectionDataHeader::find($id);
            $recordData = DailyQualityBagInspectionData::where('dq_bag_inspection_id', '=', $id)->get();

            $recordHead->request_data = $recordData;

            $responseBody = $this->responseBody(true, "DailyQualityBagInspectionDataController", "getBiData", $recordHead);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "DailyQualityBagInspectionDataController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }








    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
