var action = "save";
var electrical_conductivity_id = "";
var tableData = undefined;
$(document).ready(function () {
    tableData = $("#tblData").transactionTable({
        thead: ["Hour", "EC unit (µS/cm)", "Color", "Remarks"],
        column_def: { 0: 100 },
        auto_focus: 0,
        row_type: [
            { type: "select", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "text", value: "", align: "left" },
            { type: "remove", value: "X", align: "right" },
        ],
    });

    getOrderNo();
    getProductPrimaryId();
    getFactoryData();

    if (window.location.search.length > 0) {
        var sPageURL = window.location.search.substring(1);
        var param = sPageURL.split("?");
        electrical_conductivity_id = param[0].split("=")[1].split("&")[0];
        action = param[0].split("=")[2].split("&")[0];
        getEcData(electrical_conductivity_id);
        if (action == "edit") {
            $("#btnSave").text("Update");
        } else if (action == "view") {
            $("#btnSave").hide();
            $("#addRowBtn").hide();
            $("#reference_no").prop("disabled", true);
            $("#product_primary_id").prop("disabled", true);
            $("#customer_order_plan_data_id").prop("disabled", true);
            $("#date").prop("disabled", true);
            $("#factory").prop("disabled", true);
            $("#item").prop("disabled", true);
            $("#method").prop("disabled", true);
            $("#quantity").prop("disabled", true);
        }
    } else {
        tableData.add_empty_row();
    }

    $("#btnSave").on("click", function () {
        if ($(this).text() == "Save") {
            saveEcRecord();
        } else {
            updateEcRecords(electrical_conductivity_id);
        }
    });

    addRowData();
});

function addEmptyRow() {
    tableData.add_empty_row();
    addRowData();
}

function addRowData(hour) {
    var selected_row = tableData.getSelectedRow();
    var cells = selected_row.getElementsByTagName("td");

    $("#" + cells[0].childNodes[0].id).append('<option value="">--</option>');

    for (var i = 1; i < 25; i++) {
        if (hour == i) {
            $("#" + cells[0].childNodes[0].id).append(
                '<option value="' + i + '" selected>' + i + "</option>"
            );
        } else {
            $("#" + cells[0].childNodes[0].id).append(
                '<option value="' + i + '">' + i + "</option>"
            );
        }
    }
}

function getFactoryData() {
    $.ajax({
        type: "GET",
        url: "/qc/SupervisorCheckListDataController/getFactoryData",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#factory").append(
                    '<option value="' +
                        res[i].site_id +
                        '">' +
                        res[i].site +
                        "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {},
    });
}

function getOrderNo() {
    $.ajax({
        type: "GET",
        url: "/qc/DamageCheckingRecordsHeaderController/getOrderNo",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#customer_order_plan_data_id").append(
                    '<option value="' +
                        res[i].customer_order_plan_data_id +
                        '">' +
                        res[i].order_id +
                        "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {},
    });
}

function getProductPrimaryId() {
    $.ajax({
        type: "GET",
        url: "/qc/DamageCheckingRecordsHeaderController/getProductPrimaryId",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            var res = response.data.result;
            for (var i = 0; i < res.length; i++) {
                $("#product_primary_id").append(
                    '<option value="' +
                        res[i].product_primary_id +
                        '">' +
                        res[i].product_name +
                        "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {},
    });
}

function saveEcRecord() {
    var ec_data = {};
    var ec_data_arr = tableData.dataSource();
    if (ec_data_arr.length == 0) {
        showWarningMessage("Invalid data!");
        return;
    }
    for (var i = 0; i < ec_data_arr.length; i++) {
        if (!ec_data_arr[i][0]) {
            showWarningMessage("You shuld fill empty row in The list");
            return;
        }
        ec_data[i] = JSON.stringify({
            hour: ec_data_arr[i][0],
            ec_unit: ec_data_arr[i][1],
            color: ec_data_arr[i][2],
            remarks: ec_data_arr[i][3],
        });
    }

    $.ajax({
        type: "POST",
        url: "/qc/ElectricalConductivityCheckListDataController/save",
        data: {
            reference_no: $("#reference_no").val(),
            date: $("#date").val(),
            customer_order_plan_data_id: $(
                "#customer_order_plan_data_id"
            ).val(),
            product_primary_id: $("#product_primary_id").val(),
            factory: $("#factory").val(),
            item: $("#item").val(),
            quantity: $("#quantity").val(),
            method: $("#method").val(),
            ec_data: ec_data,
        },
        headers: {
            "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
        },
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                toastr.success("data saved");
                $("#tblData")
                    .find("input[type=text], select")
                    .each(function () {
                        $(this).val("");
                    });

                $("#product_primary_id").val("");
                $("#customer_order_plan_data_id").val("");
                $("#date").val("");
                $("#factory").val("");
                $("#item").val("");
                $("#quantity").val("");
                $("#method").val("");
                getOrderNo();
                getProductPrimaryId();
                getFactoryData();
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error("Something went wrong");
        },
        complete: function () {},
    });
}

function getEcData(id) {
    $.ajax({
        type: "GET",
        url: "/qc/ElectricalConductivityCheckListDataController/getEcData/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            // progress(true);
        },
        success: function (response) {
            var res = response.data.result;
            $("#reference_no").val(res.reference_no);
            $("#date").val(res.date);
            $("#customer_order_plan_data_id").val(
                res.customer_order_plan_data_id
            );
            $("#product_primary_id").val(res.product_primary_id);
            $("#factory").val(res.factory);
            $("#item").val(res.item);
            $("#quantity").val(res.quantity);
            $("#method").val(res.method);

            var request_data = res.request_data;
            for (var i = 0; i < request_data.length; i++) {
                tableData.addRow([
                    {
                        type: "select",
                        val: request_data[i].hour,
                        align: "left",
                        width: "60px",
                    },
                    {
                        type: "text",
                        val: request_data[i].ec_unit,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].color,
                        align: "left",
                    },
                    {
                        type: "text",
                        val: request_data[i].remarks,
                        align: "left",
                    },
                    {
                        type: "remove",
                        val: "X",
                        align: "center",
                    },
                ]);

                addRowData(request_data[i].hour);
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {
            // progress(false);
        },
    });
}

function updateEcRecords(electrical_conductivity_id) {
    var ec_data = {};
    var ec_data_arr = tableData.dataSource();
    if (ec_data_arr.length == 0) {
        showWarningMessage("Invalied Data");
        return;
    }
    for (var i = 0; i < ec_data_arr.length; i++) {
        if (!ec_data_arr[i][0]) {
            showWarningMessage("You shuld fill empty row in The list");
            return;
        }
        ec_data[i] = JSON.stringify({
            hour: ec_data_arr[i][0],
            ec_unit: ec_data_arr[i][1],
            color: ec_data_arr[i][2],
            remarks: ec_data_arr[i][3],
        });
    }

    $.ajax({
        type: "PUT",
        url:
            "/qc/ElectricalConductivityCheckListDataController/update/" +
            electrical_conductivity_id,
        data: {
            reference_no: $("#reference_no").val(),
            date: $("#date").val(),
            customer_order_plan_data_id: $(
                "#customer_order_plan_data_id"
            ).val(),
            product_primary_id: $("#product_primary_id").val(),
            factory: $("#factory").val(),
            item: $("#item").val(),
            quantity: $("#quantity").val(),
            method: $("#method").val(),
            ec_data: ec_data,
        },
        headers: {
            "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
        },
        timeout: 800000,
        beforeSend: function () {},
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                toastr.success("data updated");
                location.href = "/qc/electricalConductivityList";
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error("Something went wrong");
        },
        complete: function () {},
    });
}

function triggerRowInputs(id, selected_row) {}

function transactionTableUpdate(table_id) {
    // override function from transaction_table.js
}

/**
 * showSuccessMessage
 * This function is used to show success message.
 * @param message This is the paramter to require message content
 */
function showSuccessMessage(message) {
    toastr.success(message);
}

/**
 * showWarningMessage
 * This function is used to show warning message.
 * @param message This is the paramter to require message content
 */
function showWarningMessage(message) {
    toastr.warning(message);
}

/**
 * showErrorMessage
 * This function is used to show error message.
 * @param message This is the paramter to require message content
 */
function showErrorMessage() {
    toastr.error("Something went wrong");
}
