<?php

use Illuminate\Support\Facades\Route;
use Modules\Qc\Http\Controllers\DamageCheckingRecordsHeaderController;
use Modules\Qc\Http\Controllers\DamageCheckingRecordsDataController;
use Modules\Qc\Http\Controllers\PackingLineQualityRecordDataController;
use Modules\Qc\Http\Controllers\PackingLineQualityRecordHeaderController;
use Modules\Qc\Http\Controllers\SupervisorCheckListDataController;
use Modules\Qc\Http\Controllers\SupervisorCheckListHeaderController;
use Modules\Qc\Http\Controllers\SettingsController;
use Modules\Qc\Http\Controllers\NcrRecordAttachmentController;
use Modules\Qc\Http\Controllers\NcrRecordController;
use Modules\Qc\Http\Controllers\DailyQualityBagInspectionDataController;
use Modules\Qc\Http\Controllers\DailyQualityBagInspectionDataHeaderController;
use Modules\Qc\Http\Controllers\ElectricalConductivityCheckListDataController;
use Modules\Qc\Http\Controllers\ElectricalConductivityCheckListHeaderController;
use Modules\Qc\Http\Controllers\ProductionWeightReportController;
use Modules\Qc\Http\Controllers\ProductionWeightReportHeaderController;
use Modules\Qc\Http\Controllers\PallatizingDetailsDataController;
use Modules\Qc\Http\Controllers\PallatizingDetailsHeaderController;
use Modules\Qc\Http\Controllers\QualityInspectionExpansionDataController;
use Modules\Qc\Http\Controllers\QualityInspectionExpansionHeaderController;
use Modules\Qc\Http\Controllers\IacListController;


Route::prefix('qc')->group(function() {
    Route::get('/dashboard', function () {
        return view('qc::dashboard');
    })->middleware('is.logged');

    Route::get('/damageCheckingList', function () {
        return view('qc::damage_checking_records_list');
    })->middleware('is.logged');

    Route::get('/damageChecking', function () {
        return view('qc::damage_checking_records');
    })->middleware('is.logged');

    Route::get('/packingLineList', function () {
        return view('qc::packing_line_quality_records_list');
    })->middleware('is.logged');

    Route::get('/packingLine', function () {
        return view('qc::packing_line_quality_records');
    })->middleware('is.logged');

    Route::get('/supervisorChecking', function () {
        return view('qc::supervisor_check_list_data');
    })->middleware('is.logged');

    Route::get('/supervisorCheckingList', function () {
        return view('qc::supervisor_check_list_header');
    })->middleware('is.logged');

    Route::get('/settings', function () {
        return view('qc::settings');
    })->middleware('is.logged');

    Route::get('/ncrRecordList', function () {
        return view('qc::ncr_record_list');
    })->middleware('is.logged');

    Route::get('/dqBagInspection', function () {
        return view('qc::daily_quality_bag_inspection');
    })->middleware('is.logged');

    Route::get('/dqBagInspectionList', function () {
        return view('qc::daily_quality_bag_inspection_list');
    })->middleware('is.logged');

    Route::get('/electricalConductivity', function () {
        return view('qc::electrical_conductivity_data');
    })->middleware('is.logged');

    Route::get('/electricalConductivityList', function () {
        return view('qc::electrical_conductivity_list');
    })->middleware('is.logged');

    Route::get('/pwReport', function () {
        return view('qc::production_weight_report');
    })->middleware('is.logged');

    Route::get('/pwReportsList', function () {
        return view('qc::production_weight_report_list');
    })->middleware('is.logged');

    Route::get('/pallatizingDetails', function () {
        return view('qc::pallatizing_details');
    })->middleware('is.logged');

    Route::get('/pallatizingDetailsList', function () {
        return view('qc::pallatizing_details_list');
    })->middleware('is.logged');

    Route::get('/qiExpansion', function () {
        return view('qc::quality_inspection_expansion');
    })->middleware('is.logged');

    Route::get('/qiExpansionList', function () {
        return view('qc::quality_inspection_expansion_list');
    })->middleware('is.logged');

    Route::get('/internalAudit', function () {
        return view('qc::iac_list');
    })->middleware('is.logged');


    Route::post('/damageCheckingRecordsDataController/save', [DamageCheckingRecordsDataController::class, 'save']);
    Route::get('/DamageCheckingRecordsDataController/getShiftData', [DamageCheckingRecordsDataController::class, 'getShiftData']);
    Route::get('/damageCheckingRecordsDataController/getDcData/{id}', [DamageCheckingRecordsDataController::class, 'getDcData']);
    Route::put('/DamageCheckingRecordsDataController/update/{id}', [DamageCheckingRecordsDataController::class, 'update']);


    Route::get('/DamageCheckingRecordsHeaderController/records', [DamageCheckingRecordsHeaderController::class, 'allRecords']);
    Route::get('/DamageCheckingRecordsHeaderController/getOrderNo', [DamageCheckingRecordsHeaderController::class, 'getOrderNo']);
    Route::get('/DamageCheckingRecordsHeaderController/getProductPrimaryId', [DamageCheckingRecordsHeaderController::class, 'getProductPrimaryId']);
    Route::delete('/DamageCheckingRecordsHeaderController/delete/{id}', [DamageCheckingRecordsHeaderController::class, 'deleteRecord']);
    Route::get('/DamageCheckingRecordsHeaderController/damageCheckingReport/{id}', [DamageCheckingRecordsHeaderController::class, 'damageCheckingReport']);


    Route::post('/PackingLineQualityRecordDataController/save', [PackingLineQualityRecordDataController::class, 'save']);
    Route::get('/PackingLineQualityRecordDataController/getCheckedBy', [PackingLineQualityRecordDataController::class, 'getCheckedBy']);
    Route::get('/PackingLineQualityRecordDataController/getPlqData/{id}', [PackingLineQualityRecordDataController::class, 'getPlqData']);
    Route::put('/PackingLineQualityRecordDataController/update/{id}', [PackingLineQualityRecordDataController::class, 'update']);


    Route::get('/PackingLineQualityRecordHeaderController/records', [PackingLineQualityRecordHeaderController::class, 'allRecords']);
    Route::delete('/PackingLineQualityRecordHeaderController/delete/{id}', [PackingLineQualityRecordHeaderController::class, 'deleteRecord']);
    Route::get('/PackingLineQualityRecordHeaderController/packingLineReport/{id}', [PackingLineQualityRecordHeaderController::class, 'packingLineReport']);


    Route::get('/SupervisorCheckListDataController/getMachineryData', [SupervisorCheckListDataController::class, 'getMachineryData']);
    Route::get('/SupervisorCheckListDataController/getMaterialData', [SupervisorCheckListDataController::class, 'getMaterialData']);
    Route::get('/SupervisorCheckListDataController/getFactoryData', [SupervisorCheckListDataController::class, 'getFactoryData']);
    Route::post('/SupervisorCheckListDataController/save', [SupervisorCheckListDataController::class, 'save']);
    Route::get('/SupervisorCheckListDataController/getSclData/{id}', [SupervisorCheckListDataController::class, 'getSclData']);
    Route::put('/SupervisorCheckListDataController/update/{id}', [SupervisorCheckListDataController::class, 'update']);


    Route::get('/SupervisorCheckListHeaderController/records', [SupervisorCheckListHeaderController::class, 'allRecords']);
    Route::delete('/SupervisorCheckListHeaderController/delete/{id}', [SupervisorCheckListHeaderController::class, 'deleteRecord']);
    Route::get('/SupervisorCheckListHeaderController/supervisorCheckListReport/{id}', [SupervisorCheckListHeaderController::class, 'supervisorCheckListReport']);


    Route::post('/SettingsController/saveMaterialType', [SettingsController::class, 'saveMaterialType']);
    Route::get('/SettingsController/getAllMaterialType', [SettingsController::class, 'getAllMaterialType']);
    Route::get('/SettingsController/getMaterialType/{id}', [SettingsController::class, 'getMaterialType']);
    Route::put('/SettingsController/updateMaterialType/{id}', [SettingsController::class, 'updateMaterialType']);
    Route::put('/SettingsController/disableMaterialType/{id}', [SettingsController::class, 'disableMaterialType']);


    Route::post('/NcrRecordAttachmentController/uploadAttachment', [NcrRecordAttachmentController::class, 'uploadAttachment'])->name('/NcrRecordAttachmentController/uploadAttachment');


    Route::delete('/NcrRecordController/delete/{id}', [NcrRecordController::class, 'deleteRecord']);
    Route::get('/NcrRecordController/records', [NcrRecordController::class, 'allNcrRecords']);
    Route::post('/NcrRecordController/save', [NcrRecordController::class, 'saveNcrRecord']);
    Route::put('/NcrRecordController/update/{id}', [NcrRecordController::class, 'update']);
    Route::get('/NcrRecordController/getNcrData/{id}', [NcrRecordController::class, 'getNcrData']);


    Route::post('/DailyQualityBagInspectionDataController/save', [DailyQualityBagInspectionDataController::class, 'save']);
    Route::get('/DailyQualityBagInspectionDataController/getBiData/{id}', [DailyQualityBagInspectionDataController::class, 'getBiData']);
    Route::put('/DailyQualityBagInspectionDataController/update/{id}', [DailyQualityBagInspectionDataController::class, 'update']);


    Route::get('/DailyQualityBagInspectionDataHeaderController/records', [DailyQualityBagInspectionDataHeaderController::class, 'allRecords']);
    Route::delete('/DailyQualityBagInspectionDataHeaderController/delete/{id}', [DailyQualityBagInspectionDataHeaderController::class, 'deleteRecord']);


    Route::post('/ElectricalConductivityCheckListDataController/save', [ElectricalConductivityCheckListDataController::class, 'save']);
    Route::get('/ElectricalConductivityCheckListDataController/getEcData/{id}', [ElectricalConductivityCheckListDataController::class, 'getEcData']);
    Route::put('/ElectricalConductivityCheckListDataController/update/{id}', [ElectricalConductivityCheckListDataController::class, 'update']);


    Route::get('/ElectricalConductivityCheckListHeaderController/records', [ElectricalConductivityCheckListHeaderController::class, 'allRecords']);
    Route::delete('/ElectricalConductivityCheckListHeaderController/delete/{id}', [ElectricalConductivityCheckListHeaderController::class, 'deleteRecord']);


    Route::post('/ProductionWeightReportController/save', [ProductionWeightReportController::class, 'save']);
    Route::get('/ProductionWeightReportController/getPwrData/{id}', [ProductionWeightReportController::class, 'getPwrData']);
    Route::put('/ProductionWeightReportController/update/{id}', [ProductionWeightReportController::class, 'update']);


    Route::get('/ProductionWeightReportHeaderController/records', [ProductionWeightReportHeaderController::class, 'allRecords']);
    Route::delete('/ProductionWeightReportHeaderController/delete/{id}', [ProductionWeightReportHeaderController::class, 'deleteRecord']);


    Route::post('/PallatizingDetailsDataController/save', [PallatizingDetailsDataController::class, 'save']);
    Route::get('/PallatizingDetailsDataController/getPdData/{id}', [PallatizingDetailsDataController::class, 'getPdData']);
    Route::put('/PallatizingDetailsDataController/update/{id}', [PallatizingDetailsDataController::class, 'update']);


    Route::get('/PallatizingDetailsHeaderController/records', [PallatizingDetailsHeaderController::class, 'allRecords']);
    Route::delete('/PallatizingDetailsHeaderController/delete/{id}', [PallatizingDetailsHeaderController::class, 'deleteRecord']);


    Route::post('/QualityInspectionExpansionDataController/save', [QualityInspectionExpansionDataController::class, 'save']);
    Route::get('/QualityInspectionExpansionDataController/getQieData/{id}', [QualityInspectionExpansionDataController::class, 'getQieData']);
    Route::put('/QualityInspectionExpansionDataController/update/{id}', [QualityInspectionExpansionDataController::class, 'update']);


    Route::get('/QualityInspectionExpansionHeaderController/records', [QualityInspectionExpansionHeaderController::class, 'allRecords']);
    Route::delete('/QualityInspectionExpansionHeaderController/delete/{id}', [QualityInspectionExpansionHeaderController::class, 'deleteRecord']);


    Route::post('/IacListController/uploadAttachment', [IacListController::class, 'uploadAttachment'])->name('/IacListController/uploadAttachment');
    Route::delete('/IacListController/delete/{id}', [IacListController::class, 'deleteRecord']);
    Route::get('/IacListController/records', [IacListController::class, 'allIacLists']);
    Route::post('/IacListController/save', [IacListController::class, 'saveIacList']);
    Route::put('/IacListController/update/{id}', [IacListController::class, 'update']);
    Route::get('/IacListController/getIaclData/{id}', [IacListController::class, 'getIaclData']);
});
